Imports System
Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.ComponentModel

<ValidationPropertyAttribute("CalendarDateString")> _
Partial Public Class DatePicker

    Inherits System.Web.UI.UserControl
    ' date format used by the calendar control 
    Private Const DateFormat As String = "MM/dd/yyyy"

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

        Dim path As String
        path = Me.TemplateSourceDirectory
        If Not path.EndsWith("/") Then
            path &= "/"
        End If
        path &= "DatePicker/"

        ' links to CSS and JS files in "DatePicker" subdirectory 
        litCSS.Text = "<link href='" & path & "popcalendar.css" & "' type=""text/css"" rel=""stylesheet"" />"
        litJS.Text = "<script language=""javascript"" src='" & path & "popcalendar.js" & "' type=""text/javascript""></script>"

        Dim scriptStr As String = "javascript:return popUpCalendar(this, '" & path
        scriptStr &= "', document.getElementById('" + getClientID() & "'), '" + DateFormat & "')"
        imgCalendar.Attributes.Add("onclick", scriptStr)

    End Sub

    ' Get the id of the control rendered on client side 
    ' Very essential for Javascript Calendar scripts to locate the textbox 
    Public Function getClientID() As String
        Return txt_Date.ClientID
    End Function

    <Category("Appearance")> _
    <Description("CSS class name applied to the text box.")> _
    <Browsable(True)> _
    Public Property TextCssClass() As String
        Get
            Return txt_Date.CssClass
        End Get
        Set(ByVal value As String)
            txt_Date.CssClass = value
        End Set
    End Property

    ''' <summary> 
    ''' Gets or sets the content of the textbox which represents a date. 
    ''' </summary> 
    <Bindable(True, BindingDirection.TwoWay)> _
    <Browsable(True)> _
    Public Property CalendarDateString() As String
        Get
            Return txt_Date.Text
        End Get
        Set(ByVal value As String)
            txt_Date.Text = value
            Dim [date] As DateTime
            If DateTime.TryParseExact(value, DateFormat, Nothing, System.Globalization.DateTimeStyles.None, [date]) Then
                If [date].[Date] = DateTime.MaxValue.[Date] Then
                    txt_Date.Text = ""
                End If
            End If
        End Set
    End Property

    ''' <summary> 
    ''' Gets or sets a DateTime representation of the currently selected date. 
    ''' </summary> 
    <Bindable(True, BindingDirection.TwoWay)> _
    <Browsable(True)> _
    Public Property CalendarDate() As DateTime
        Get
            Dim [date] As DateTime
            If DateTime.TryParseExact(txt_Date.Text, DateFormat, Nothing, System.Globalization.DateTimeStyles.None, [date]) Then
                Return [date]
            End If
            Return DateTime.MaxValue
        End Get
        Set(ByVal value As DateTime)
            txt_Date.Text = value.ToString(DateFormat)
        End Set
    End Property
End Class
